VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form DataPump 
   Caption         =   "Data Pump EXE Example"
   ClientHeight    =   3630
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7485
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3630
   ScaleWidth      =   7485
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   4800
      Top             =   1560
   End
   Begin ComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   360
      Left            =   0
      TabIndex        =   4
      Top             =   3270
      Width           =   7485
      _ExtentX        =   13203
      _ExtentY        =   635
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   2
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            AutoSize        =   1
            Object.Width           =   6324
            Text            =   "UserID:"
            TextSave        =   "UserID:"
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
         BeginProperty Panel2 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            AutoSize        =   1
            Object.Width           =   6324
            Text            =   "Password:"
            TextSave        =   "Password:"
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.CommandButton Add 
      Caption         =   "&Add Symbol"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   2640
      Width           =   2175
   End
   Begin VB.TextBox Text1 
      Height          =   1005
      Left            =   4800
      MultiLine       =   -1  'True
      TabIndex        =   2
      Text            =   "Data Pump EXE Example.frx":0000
      Top             =   120
      Visible         =   0   'False
      Width           =   2355
   End
   Begin ComctlLib.ListView ListView1 
      Height          =   2415
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4455
      _ExtentX        =   7858
      _ExtentY        =   4260
      View            =   3
      LabelEdit       =   1
      Sorted          =   -1  'True
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   5
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Symbol"
         Object.Width           =   1324
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Description"
         Object.Width           =   2646
      EndProperty
      BeginProperty ColumnHeader(3) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   2
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Category"
         Object.Width           =   3528
      EndProperty
      BeginProperty ColumnHeader(4) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   3
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Start Date"
         Object.Width           =   1323
      EndProperty
      BeginProperty ColumnHeader(5) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   4
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Bar Interval"
         Object.Width           =   1323
      EndProperty
   End
   Begin VB.CommandButton Remove 
      Caption         =   "&Remove Symbol(s)"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2400
      TabIndex        =   1
      Top             =   2640
      Width           =   2175
   End
End
Attribute VB_Name = "DataPump"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ********************************************
' DATA PUMP EXAMPLE CONSTANTS
'
' These constants control the data mode, interface mode, etc. of the example.
'
' Keep in mind that the example was built to be a single example that can be configured for
' the many different ways of interfacing with the NeuroShell Trader DataPump.  Towards that
' goal, these constants are what you use to control the type of interface used by the example.
'

Private Const DATAMODE = 3   ' DATAMODE = 1 emulates a server that receives historical bar data and historical bar updates in realtime
                             ' DATAMODE = 2 emulates a server that receives historical bar data, but realtime tick updates in realtime
                             ' DATAMODE = 3 emulates a server that receives only tick by tick historical and realtime updates

'This allows the server to receive requests from NeuroShell Trader when a new ticker is desired
' - This is meant to be used in conjunction with LST files found in a subdirectory of the Servers directory
' - that has the same name as your "Server.EXE".  We've provided you with the NASDAQ100.LST file as an example
' - of how to use/create the LST file for the "Data Pump EXE Example"
Private Const ReceiveNSTTickerRequests = True

'This turns on the add/remove buttons so that a user can add/remove tickers
' - This may be desirable if your server is running all the time in order to receive ticks (i.e. your server doesn't receive historical updates)
Private Const AllowUserAddRemove = False

'This will end the server program upon a server change or NeuroShell Trader ending
' - This may not be desirable if you need to be running your server all the time to receive ticks (i.e. your server doesn't receive historical updates)
Private Const EndOnServerChange = True

'This will inform NeuroShell Trader that a UserID and Password are required
' - NeuroShell Trader will prompt the user for the UserID and Password, then inform this server
' - when there is a "new" UserID/Password, at which point it can be retrieved.
Private Const UserIDPasswordRequired = True
Private Const DisplayUserIDPassword = False

' ******************************************
' Variables
'

Private ListViewColumnNames As New Collection

Private SaveList As Boolean
Private AppPath As String

Private InitialWidth As Single
Private InitialHeight As Single

Private lastusedate As Double

Private AddTickerFlag As Boolean

Private Sub Form_Load()
    Dim ListFile As Long
    Dim TempString As String
    Dim NewListItem As ListItem
    Dim i As Long
    Dim Columns As New Collection
    Dim customvalue As Double
    
    CloseVal = 30       ' starting closing price
    
    'Only need to set the handle if receiving events from NeuroShell Trader
    If UserIDPasswordRequired Or ReceiveNSTTickerRequests Or EndOnServerChange Then
        SetDataFeedhwnd Text1.hWnd
    End If
    
    'If a UserID/Password is required call RequireUserIDPassword
    If UserIDPasswordRequired Then
        RequireUserIDPassword 'this is not necessary because a UserID/Password is not required
    End If
    
    InitialWidth = Width
    InitialHeight = Height
    
    Top = (Screen.Height - Height) / 2
    Left = (Screen.Width - Width) / 2
    
    If Right$(App.Path, 1) <> "\" Then
        AppPath = App.Path
    Else
        AppPath = Left$(App.Path, Len(App.Path) - 1)
    End If
        
    If Dir(AppPath + "\Data Pump EXE Example List.DAT") <> "" And AllowUserAddRemove Then
        ListFile = FreeFile
        Open AppPath + "\Data Pump EXE Example List.DAT" For Input As ListFile
        On Error GoTo ListError:
        While Not EOF(ListFile)
            Line Input #ListFile, TempString
            
            Set NewListItem = ListView1.ListItems.Add()
            NewListItem.Text = Left$(TempString, InStr(TempString, "!@#") - 1)
            TempString = Right$(TempString, Len(TempString) - InStr(TempString, "!@#") - 2)
            NewListItem.SubItems(1) = Left$(TempString, InStr(TempString, "!@#") - 1)
            TempString = Right$(TempString, Len(TempString) - InStr(TempString, "!@#") - 2)
            NewListItem.SubItems(2) = Left$(TempString, InStr(TempString, "!@#") - 1)
            TempString = Right$(TempString, Len(TempString) - InStr(TempString, "!@#") - 2)
            NewListItem.SubItems(3) = Left$(TempString, InStr(TempString, "!@#") - 1)
            TempString = Right$(TempString, Len(TempString) - InStr(TempString, "!@#") - 2)
            NewListItem.SubItems(4) = TempString
            
            Set Columns = New Collection
            If Val(NewListItem.SubItems(4)) = 0 Then
                Columns.Add "Date/Time"
                Columns.Add "Close"
                Columns.Add "Volume"
            Else
                Columns.Add "Date/Time"
                Columns.Add "Open"
                Columns.Add "High"
                Columns.Add "Low"
                Columns.Add "Close"
                Columns.Add "Volume"
            End If
            
            ListViewColumnNames.Add Columns, NewListItem.Text + "!@#" + NewListItem.SubItems(4)
        Wend
On Error GoTo 0:
ResumeListError:
        Close #ListFile

        For i = 1 To ListView1.ListItems.Count
            AddTicker ListView1.ListItems(i).Text, ListView1.ListItems(i).SubItems(1), ListView1.ListItems(i).SubItems(2), ListView1.ListItems(i).SubItems(4), CVDate(ListView1.ListItems(i).SubItems(3)), Columns, True
        Next i
    End If
Exit Sub
ListError:
    MsgBox "An Error has occured while trying to read Data Pump EXE Example List.DAT.  Please correct this error by using a text editor to correctly format the file or delete the file and reconfigure your list of symbols to it's original setting (using the Add Symbol button).", vbCritical, "Error"
    
    ListView1.ListItems.Clear
    Resume ResumeListError:
End Sub

Private Sub Form_Resize()
    If WindowState <> 0 Then Exit Sub
    
    If Width < InitialWidth Then Width = InitialWidth
    If Height < InitialHeight Then Height = InitialHeight
    
    ListView1.Width = Width - 360
    ListView1.Height = Height + AllowUserAddRemove * (Add.Height + 50) + DisplayUserIDPassword * (StatusBar1.Height + 50) - 700
    If DisplayUserIDPassword Then
        StatusBar1.Visible = True
    Else
        StatusBar1.Visible = False
    End If
    
    Add.Top = ListView1.Top + ListView1.Height + 105
    Remove.Top = Add.Top
    
    If AllowUserAddRemove Then
        Add.Visible = True
        Remove.Visible = True
        
        Add.Width = (ListView1.Width - 105) / 2
        Remove.Left = Add.Left + Add.Width + 105
        Remove.Width = (ListView1.Width - 210) / 2
    Else
        Add.Visible = False
        Remove.Visible = False
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim ListFile As Long
    Dim i As Integer
       
    If SaveList Then
        ListFile = FreeFile
        Open AppPath + "\Data Pump EXE Example List.DAT" For Output As ListFile
        For i = 1 To ListView1.ListItems.Count
            Print #ListFile, ListView1.ListItems(i).Text + "!@#" + ListView1.ListItems(i).SubItems(1) + "!@#" + ListView1.ListItems(i).SubItems(2) + "!@#" + ListView1.ListItems(i).SubItems(3) + "!@#" + ListView1.ListItems(i).SubItems(4)
        Next i
        Close #ListFile
    End If
    
    'Only need to set the handle if receiving events from NeuroShell Trader
    If UserIDPasswordRequired Or ReceiveNSTTickerRequests Or EndOnServerChange Then
        SetDataFeedhwnd 0
    End If
    
    End
End Sub

Private Sub ListView1_ColumnClick(ByVal ColumnHeader As ComctlLib.ColumnHeader)
    Dim i As Integer
    Dim Item As ListItem
        
    ListView1.Enabled = False
    If ColumnHeader.Index = 4 Then
        For i = 1 To ListView1.ListItems.Count
            Set Item = ListView1.ListItems(i)
            If Item.SubItems(ColumnHeader.Index - 1) <> "" Then
                Item.SubItems(ColumnHeader.Index - 1) = Format$(CDbl(CVDate(Item.SubItems(ColumnHeader.Index - 1))), "000000")
            End If
        Next i
    End If
    
    If ColumnHeader.Index = ListView1.SortKey + 1 Then
        If ListView1.SortOrder = lvwAscending Then
            ListView1.SortOrder = lvwDescending
        Else
            ListView1.SortOrder = lvwAscending
        End If
    Else
        ListView1.SortKey = ColumnHeader.Index - 1
        ListView1.SortOrder = lvwAscending
    End If
    ListView1.Sorted = True
    
    If ColumnHeader.Index = 4 Then
        For i = 1 To ListView1.ListItems.Count
            Set Item = ListView1.ListItems(i)
            If Item.SubItems(ColumnHeader.Index - 1) <> "" Then
                Item.SubItems(ColumnHeader.Index - 1) = Format(Item.SubItems(ColumnHeader.Index - 1), "Short Date")
            End If
        Next i
    End If
    ListView1.Enabled = True
End Sub

Private Sub ListView1_KeyUp(KeyCode As Integer, Shift As Integer)
    Dim i As Integer
    
    For i = 1 To ListView1.ListItems.Count
        If ListView1.ListItems(i).Selected Then
            Exit For
        End If
    Next i
    
    If i <= ListView1.ListItems.Count Then
        Remove.Enabled = True
    Else
        Remove.Enabled = False
    End If
End Sub

Private Sub ListView1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim i As Integer
    
    For i = 1 To ListView1.ListItems.Count
        If ListView1.ListItems(i).Selected Then
            Exit For
        End If
    Next i
    
    If i <= ListView1.ListItems.Count Then
        Remove.Enabled = True
    Else
        Remove.Enabled = False
    End If
End Sub

Private Sub Add_Click()
    
    ' *****************************************
    ' Add a ticker symbol (user added)
    ' *****************************************
    
    Dim NewListItem As ListItem
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    Dim RemoveCount As Integer
    Dim DeactivateCount As Integer
    Dim AddGetNextTicker As Collection
    Dim TempFileName As String
    Dim TempVariant As Variant
    
    Dim BarInterval As Double
    
    Dim Columns As New Collection
    
    Screen.MousePointer = 11 ' show hourglass while loading
    Load DataPumpNewTicker
    
    DataPumpNewTicker.Left = Me.Left + 500
    DataPumpNewTicker.Top = Me.Top + 500
    
    DataPumpNewTicker.Show 1
    
    If Not DataPumpNewTicker.CancelFlag Then
        For i = 1 To ListView1.ListItems.Count
            If ListView1.ListItems(i).Text = DataPumpNewTicker.Symbol.Text And Val(ListView1.ListItems(i).SubItems(4)) = Val(DataPumpNewTicker.BarInterval.Text) Then
                Exit For
            End If
        Next i
        
        If i > ListView1.ListItems.Count Then
            SaveList = AllowUserAddRemove
            
            'Item doesn't exist need to add
            Set NewListItem = ListView1.ListItems.Add()
            NewListItem.Text = DataPumpNewTicker.Symbol.Text
            NewListItem.SubItems(1) = DataPumpNewTicker.SymbolName.Text
            NewListItem.SubItems(2) = DataPumpNewTicker.Category.Text
            NewListItem.SubItems(3) = DataPumpNewTicker.StartDate.Text
            NewListItem.SubItems(4) = DataPumpNewTicker.BarInterval.Text
                        
            If Val(DataPumpNewTicker.BarInterval.Text) = 0 Then
                Columns.Add "Date/Time"
                Columns.Add "Close"
                Columns.Add "Volume"
            Else
                Columns.Add "Date/Time"
                Columns.Add "Open"
                Columns.Add "High"
                Columns.Add "Low"
                Columns.Add "Close"
                Columns.Add "Volume"
            End If
            
            ListViewColumnNames.Add Columns, DataPumpNewTicker.Symbol.Text + "!@#" + DataPumpNewTicker.BarInterval.Text
            AddTicker NewListItem.Text, NewListItem.SubItems(1), NewListItem.SubItems(2), Val(NewListItem.SubItems(4)), CVDate(NewListItem.SubItems(3)), Columns, True
        End If
    End If
    
    Unload DataPumpNewTicker
    
    Screen.MousePointer = 1: Screen.MousePointer = 0 ' show default mousepointer
End Sub

Private Sub Remove_Click()
    Dim i As Integer
    
    ' *****************************************
    ' Remove a ticker symbol added by the user
    ' *****************************************
    
    For i = ListView1.ListItems.Count To 1 Step -1
        If ListView1.ListItems(i).Selected Then
            SaveList = True
            ListView1.ListItems.Remove i
        End If
    Next i
    
    Remove.Enabled = False
End Sub

Private Sub Text1_Change()

    ' *****************************************************
    ' Receive Command from NeuroShell Trader (via text box)
    ' *****************************************************

    Dim ticker As String
    Dim description As String
    Dim Category As String
    Dim BarInterval As Double
    Dim TempBarInterval As String
    Dim StartDate As String
    Dim ColumnNames As String
    Dim ColumnName As String
    
    Dim TempUserID As String * 21
    Dim TempPassword As String * 21
    Dim UserID As String
    Dim Password As String
    
    Dim NewListItem As ListItem
    Dim TempVariant As Variant
    
    Dim delay As Double
    
    Dim i As Long
    
    Dim Columns As New Collection
    
    If Text1.Text <> "" Then
        If Text1.Text = "*****UnloadEXE*****" Then
            'NeuroShell Trader is ending - for most servers we would just end, but you
            'may want to keep the interface running if you need to keep the server up to collect ticks
            'in which case you can just ignore this event from NeuroShell Trader
            If EndOnServerChange Then
                Unload Me
                End
            End If
            
            'if this program required a UserID/Password it would need to call RequireUserIDPassword again because it's reset by NST when NST is unloading
            'RequireUserIDPassword 'this is commented out because no UserID/Password is required
        ElseIf Text1.Text = "*****UserIDPassword*****" Then
            'The UserIDPassword has changed use 'GetUserIDPassword' to get the changed UserID/Password
            If UserIDPasswordRequired Then
                GetUserIDPassword TempUserID, TempPassword
                
                UserID = TempUserID
                While Asc(Right$(UserID, 1)) = 0
                    UserID = Left$(UserID, Len(UserID) - 1)
                Wend
                Password = TempPassword
                While Asc(Right$(Password, 1)) = 0
                    Password = Left$(Password, Len(Password) - 1)
                Wend
                
                StatusBar1.Panels(1).Text = "UserID: " + UserID
                StatusBar1.Panels(2).Text = "Password: " + Password
            End If
        ElseIf InStr(Text1.Text, "*****RemoveTicker*****") Then
            ticker = Right$(Text1.Text, Len(Text1.Text) - InStr(Text1.Text, "!@#") - 2)
            TempBarInterval = Right$(ticker, Len(ticker) - InStr(ticker, "!@#") - 2)
            
            ticker = Trim$(Left$(ticker, InStr(ticker, "!@#") - 1))
            BarInterval = Val(TempBarInterval)
            
            For i = 1 To ListView1.ListItems.Count
                If ListView1.ListItems(i).Text = ticker And (Val(ListView1.ListItems(i).SubItems(4)) = BarInterval Or Val(ListView1.ListItems(i).SubItems(4)) = -BarInterval) Then
                    If DATAMODE = 2 Then
                        ListViewColumnNames.Remove ticker + "!@#" + Trim$(Str$(-BarInterval))
                    Else
                        ListViewColumnNames.Remove ticker + "!@#" + Trim$(Str$(BarInterval))
                    End If
                    ListView1.ListItems.Remove i
                    Exit For
                End If
            Next i
        Else
            If ReceiveNSTTickerRequests Then
                ticker = Trim$(Left$(Text1.Text, InStr(Text1.Text, "!@#") - 1))
                description = Right$(Text1.Text, Len(Text1.Text) - InStr(Text1.Text, "!@#") - 2)
                Category = Right$(description, Len(description) - InStr(description, "!@#") - 2)
                TempBarInterval = Right$(Category, Len(Category) - InStr(Category, "!@#") - 2)
                StartDate = Right$(TempBarInterval, Len(TempBarInterval) - InStr(TempBarInterval, "!@#") - 2)
                ColumnNames = Right$(StartDate, Len(StartDate) - InStr(StartDate, "!@#") - 2)
                
                description = Trim$(Left$(description, InStr(description, "!@#") - 1))
                Category = Trim$(Left$(Category, InStr(Category, "!@#") - 1))
                TempBarInterval = Trim$(Left$(TempBarInterval, InStr(TempBarInterval, "!@#") - 1))
                BarInterval = Val(TempBarInterval)
                StartDate = Trim$(Left(StartDate, InStr(StartDate, "!@#") - 1))
                
                ' adjust bar interval depending upon whether bar or tick data is being sent historically and realtime
                If (DATAMODE = 3) Then
                    BarInterval = 0
                ElseIf DATAMODE = 2 And BarInterval > 0 Then
                    BarInterval = -BarInterval
                End If
                
                For i = 1 To ListView1.ListItems.Count
                    If ListView1.ListItems(i).Text = DataPumpNewTicker.Symbol And (Val(ListView1.ListItems(i).SubItems(4)) = BarInterval Or Val(ListView1.ListItems(i).SubItems(4)) = -BarInterval) Then
                        Exit For
                    End If
                Next i
                
                If i > ListView1.ListItems.Count Then
                    ' parse out column names
                    While InStr(ColumnNames, ",")
                        Columns.Add Left$(ColumnNames, InStr(ColumnNames, ",") - 1)
                        ColumnNames = Right$(ColumnNames, Len(ColumnNames) - InStr(ColumnNames, ","))
                    Wend
                    Columns.Add ColumnNames
                    
                    ' If BarInterval <= 0, then remove Open, High, Low, columns since data
                    ' is sent in tick format (Close & Volume instead of OHLCV) when BarInterval < 0
                    If BarInterval <= 0.01 Then
                        For i = Columns.Count To 1 Step -1
                            If Columns(i) = "High" Or Columns(i) = "Low" Or Columns(i) = "Open" Then
                                Columns.Remove i
                            End If
                        Next i
                    End If
                    
                    ' turn off timer so no real time updates occur until after historical data is sent
                    Timer1.Enabled = False
                    
                    ' add ticker to list
                    SaveList = True
                    Set NewListItem = ListView1.ListItems.Add()
                    NewListItem.Text = ticker
                    NewListItem.SubItems(1) = description
                    NewListItem.SubItems(2) = Category
                    NewListItem.SubItems(3) = StartDate
                    NewListItem.SubItems(4) = Trim$(Str$(BarInterval))
                    ListViewColumnNames.Add Columns, ticker + "!@#" + Trim$(Str$(BarInterval))
                    
                    ' collect historical data
                    AddTicker ticker, description, Category, BarInterval, CVDate(StartDate), Columns, True
                    
                    ' start realtime updates now that historical data sent
                    Timer1.Enabled = True
                End If
                
                delay = Timer
                While Timer - delay < 1
                    DoEvents
                Wend
                UpdatePercent 100
            End If
        End If
        
        Text1.Text = ""
    End If
End Sub

Private Sub AddTicker(ticker As String, description As String, Category As String, BarInterval As Double, StartDate As Double, Columns As Collection, UpdatePercentFlag As Boolean)
    
    ' *************************************************
    ' Add a ticker symbol (NeuroShell Trader requested)
    ' *************************************************
    
    Dim Temp As Long
    Dim i As Long
    Dim j As Long
    Dim k As Long
    Dim StartTime As Double
    Dim UseDate As Double
    Dim DateIncrement As Double
    Dim Percent As Long
    Dim OldPercent As Long
    Dim ret As Long
    Dim filelogcount As Long
    
    AddTickerFlag = True
    
                                    ' Data Mode 1 has Positive Bar Intervals (no change to BarInterval necessary)
    If DATAMODE = 2 And BarInterval > 0 Then
        BarInterval = -BarInterval  ' Data Mode 2 has Negative Bar Intervals
    ElseIf DATAMODE = 3 Then
        BarInterval = 0             ' Data Mode 3 has Zero Bar Intervals
    End If
    
    ' *****************************
    ' setup the data and the labels
    ' *****************************
    Temp = NSTSETUPDATA(ticker, description, BarInterval, Columns.Count, Category, StartDate)
    For i = 1 To Columns.Count
        Temp = NSTSETLABEL(ticker, BarInterval, i, Columns(i))
    Next i
    
    ' *******************
    ' Add Historical Data
    ' *******************
    ' set date increment for simulated data, based upon bar interval
    If BarInterval > 0 Then
        DateIncrement = BarInterval / (24 * 60)   ' Bar Interval expressed as fraction of 24 hours
    ElseIf BarInterval < 0 Then
        DateIncrement = -BarInterval / (24 * 60)  ' Bar Interval expressed as fractuon of 24 hours
    Else
        DateIncrement = 0                         ' 0 Date Increment to signal simulated random tick date increments
    End If
    
    ' set first date to load
    UseDate = StartDate + RandomDataStartTime / 24
    
    filelogcount = 0
    Do
        If BarInterval > 0 Then
            ' OHLC Historical bars and OHLC real time updates
            ' (DataMode 1 when user creating a minute, hour, day, week or month chart)
            GetNextPriceBar
            
            ' Set OHLC and Volume data values
            ret = NSTSETVALUE(ticker, BarInterval, 1, UseDate)          'Date
            ret = NSTSETVALUE(ticker, BarInterval, 2, OpenVal)          'Open
            ret = NSTSETVALUE(ticker, BarInterval, 3, HighVal)          'High
            ret = NSTSETVALUE(ticker, BarInterval, 4, LowVal)           'Low
            ret = NSTSETVALUE(ticker, BarInterval, 5, CloseVal)         'Close
            ret = NSTSETVALUE(ticker, BarInterval, 6, VolVal)           'Volume

            ' set any other data beyond OHLC and Volume (if any)
            For k = 7 To Columns.Count
                ret = NSTSETVALUE(ticker, BarInterval, k, Rnd)
            Next k
        
            ret = NSTCOMMITROW(ticker, BarInterval)
        ElseIf BarInterval < 0 Then
            ' OHLC Historical bars and tick by tick real time updates
            ' (DataMode 2 when user creating a minute, hour, day, week or month chart)
            
            GetNextPriceBar
            
            ' NOTE: Historical OHLC set as ticks, one tick for open, one tick for high, one tick for low, and one tick for close
            
            ' Set Open tick
            ret = NSTSETVALUE(ticker, BarInterval, 1, UseDate)   ' Date
            ret = NSTSETVALUE(ticker, BarInterval, 2, OpenVal)    ' Open
            ret = NSTSETVALUE(ticker, BarInterval, 3, 0)          ' 0 volume value
            For j = 4 To Columns.Count  ' set any other data beyond OHLC and Volume (if any) to zero
                ret = NSTSETVALUE(ticker, BarInterval, j, 0)
            Next j
            ret = NSTCOMMITROW(ticker, BarInterval)
        
            ' Set High tick
            ret = NSTSETVALUE(ticker, BarInterval, 1, UseDate)   ' Date
            ret = NSTSETVALUE(ticker, BarInterval, 2, HighVal)      ' Open
            ret = NSTSETVALUE(ticker, BarInterval, 3, 0)          ' 0 volume value
            For j = 4 To Columns.Count  ' set any other data beyond OHLC and Volume (if any) to zero
                ret = NSTSETVALUE(ticker, BarInterval, j, 0)
            Next j
            ret = NSTCOMMITROW(ticker, BarInterval)
        
            ' Set Low tick
            ret = NSTSETVALUE(ticker, BarInterval, 1, UseDate)    ' Date
            ret = NSTSETVALUE(ticker, BarInterval, 2, LowVal)    ' Open
            ret = NSTSETVALUE(ticker, BarInterval, 3, 0)          ' 0 volume value
            For j = 4 To Columns.Count  ' set any other data beyond OHLC and Volume (if any) to zero
                ret = NSTSETVALUE(ticker, BarInterval, j, 0)
            Next j
            ret = NSTCOMMITROW(ticker, BarInterval)

            ' Set Closing tick
            ret = NSTSETVALUE(ticker, BarInterval, 1, UseDate)    ' Date
            ret = NSTSETVALUE(ticker, BarInterval, 2, CloseVal)   ' Open
            ret = NSTSETVALUE(ticker, BarInterval, 3, VolVal)     ' Actual volume value
            For j = 4 To Columns.Count  ' set any other data beyond OHLC and Volume (if any) to appropriate value
                ret = NSTSETVALUE(ticker, BarInterval, j, Rnd)
            Next j
            ret = NSTCOMMITROW(ticker, BarInterval)
        ElseIf BarInterval = 0 Then
            ' Tick by tick historical data
            ' (DataMode 1 and 2 when user creating a second, tick, volume or range chart)
            ' (DataMode 3 no matter what type of chart is being created)
            GetNextTick
            
            ' Set Price and Volume tick data value
            ret = NSTSETVALUE(ticker, BarInterval, 1, UseDate)    ' Date
            ret = NSTSETVALUE(ticker, BarInterval, 2, CloseVal)  ' Tick Price
            ret = NSTSETVALUE(ticker, BarInterval, 3, VolVal)     ' 0 volume value
            
            ' set any other data beyond OHLC and Volume (if any)
            For j = 4 To Columns.Count
                ret = NSTSETVALUE(ticker, BarInterval, j, Rnd)
            Next j
            
            ret = NSTCOMMITROW(ticker, BarInterval)
        End If
        
        If UpdatePercentFlag Then
            Percent = CLng(100 * (UseDate - StartDate) / ((Now() + TimeZoneBias) - StartDate))
            If Percent <> OldPercent Then
                UpdatePercent Percent
                OldPercent = Percent
            End If
        End If
        
        ' increment date to next bar of data
        If DateIncrement Then
            UseDate = UseDate + DateIncrement
        Else
            ' tick by tick simulation, so increment date by a random amount between 0 and 30 seconds
            UseDate = UseDate + 30 * Rnd() / (24# * 60# * 60#)
        End If
        
        If UseDate - Fix(UseDate) > RandomDataEndTime / 24 Then
            UseDate = Fix(UseDate) + 1 + RandomDataStartTime / 24   ' increment to next day
        End If
        
        filelogcount = filelogcount + 1
        
    Loop While UseDate < CDbl((Now() + TimeZoneBias))  ' continue filling historical data until current bar reached
    
    AddTickerFlag = False
End Sub

Private Sub Timer1_Timer()
    Dim i As Long
    Dim j As Long
    Dim UseDate As Double
    Dim ticker As String
    Dim BarInterval As Double
    Dim Columns As Collection
    Dim totalvol As Single
    Dim ret As Long
    Dim filelogcount As Long
    
    ' ******************************************************************
    ' Add RealTime Data
    '
    ' Based on the Timer to simulate new ticks arriving from data server
    ' ******************************************************************

    ' don't add ticks during addtickerflag (so that extra calls to GetNextTick not done)
    If AddTickerFlag Then Exit Sub

    Timer1.Enabled = False
    
    filelogcount = 0
    
    ' generate new data for each ticker in the list
    For i = 1 To ListView1.ListItems.Count
        ticker = ListView1.ListItems(i).Text
        BarInterval = Val(ListView1.ListItems(i).SubItems(4))
        
        Set Columns = ListViewColumnNames(ticker + "!@#" + Trim$(Str$(BarInterval)))
        
        ' generate next tick value
        GetNextTick
        
        If BarInterval > 0 Then
            ' OHLC real time updates
            UseDate = (Fix((Now() + TimeZoneBias) * (24 * 60) / BarInterval) + 1) * (BarInterval / (24 * 60))
            If UseDate > lastusedate Then
                OpenVal = CloseVal
                HighVal = CloseVal
                LowVal = CloseVal
                totalvol = VolVal
            Else
                If CloseVal > HighVal Then HighVal = CloseVal
                If CloseVal < LowVal Then LowVal = CloseVal
                totalvol = totalvol + VolVal
                VolVal = totalvol
            End If
            
            ' Set OHLC and Volume data values
            ret = NSTSETVALUE(ticker, BarInterval, 1, UseDate)          'Date
            ret = NSTSETVALUE(ticker, BarInterval, 2, OpenVal)          'Open
            ret = NSTSETVALUE(ticker, BarInterval, 3, HighVal)          'High
            ret = NSTSETVALUE(ticker, BarInterval, 4, LowVal)           'Low
            ret = NSTSETVALUE(ticker, BarInterval, 5, CloseVal)         'Close
            ret = NSTSETVALUE(ticker, BarInterval, 6, VolVal)           'Volume

            ' set any other data beyond OHLC and Volume (if any)
            For j = 7 To Columns.Count
                ret = NSTSETVALUE(ticker, BarInterval, j, Rnd)
            Next j
        
            ret = NSTCOMMITROW(ticker, BarInterval)
        Else
            ' Tick by Tick real time updates
            UseDate = (Now() + TimeZoneBias)
            
            ' Set Price and Volume data values
            ret = NSTSETVALUE(ticker, BarInterval, 1, UseDate)    ' Date
            ret = NSTSETVALUE(ticker, BarInterval, 2, CloseVal)   ' Price
            ret = NSTSETVALUE(ticker, BarInterval, 3, VolVal)     ' Volume
            
            ' set any other data beyond OHLC and Volume (if any)
            For j = 4 To Columns.Count
                ret = NSTSETVALUE(ticker, BarInterval, j, Rnd)
            Next j
            
            ret = NSTCOMMITROW(ticker, BarInterval)
        End If
        
        filelogcount = filelogcount + 1
    Next i
    
    lastusedate = UseDate
    
    If (DATAMODE = 2 Or DATAMODE = 3) Then
        ' tick by tick realtime simulation, so make next tick occur a random time between 0 and 5 seconds from now
        Timer1.Interval = CLng(Rnd() * 5000)
    End If
    Timer1.Enabled = True
End Sub

